<?php
/*************************************************************************************************************
*  Projet RAT
* page centrale de l'administration
*************************************************************************************************************/

function getmicrotime()
	{
  list($usec, $sec) = explode(" ",microtime());
  return ((float)$usec + (float)$sec);
	}
	
$time = getmicrotime();

//quelques dfinitions
//define('DEBUGMODE', 1); //affichage des infos de debug de l'admin
define('ADMINISTRATION', 1);
global $Session, $module_ecran, $datamodule;

//quelques inclusions
include '../rat_code/rat.php';
Librairie('admin');
Librairie('gsessions');
Librairie('langues');

//gestion des langues
GetParam('langint', $Session['langue_interface'], RATLANGUE_DEFAUT);
if(isset($Session['langue_edition'])) $LangueEdition = $Session['langue_edition'];
GetParam('langed', $LangueEdition, RATLANGUE_DEFAUT);
include CHEMIN_ADMIN.'messages.php';
global $LANGUES;

//autres inclusions
Librairie('personnes');
Librairie('sites');
Librairie('modules');
Librairie('utilitaires');
Librairie('adminerreurs');

/**************************************************************************************
  fonctions
**************************************************************************************/

//liste des sites auxquels l'utilisateur a droit
function LstSitesUser($userid, $site)
  {
  return Sql2options('
    SELECT distinct s.sit_id AS chp1, s.sit_nom AS chp2
    FROM ratsites AS s
      INNER JOIN ratlnk_sitegroupe AS sg ON s.sit_id=sg.sit_id
      INNER JOIN ratlnk_grppers AS gp ON sg.grp_id=gp.grp_id AND gp.pers_id='.$userid.'
    ORDER BY s.sit_id', $site);
  }

//gnration des menus d'admin
function AdminMenu($userid, $langid, $selected, &$tpl)
  {
  $req = NewQuery('
    SELECT DISTINCT gml.grl_nom, m.mod_ident, ml.mol_texte
    FROM ratmodules AS m
      INNER JOIN ratlangues AS l ON l.lang_abrege="'.$langid.'"
      INNER JOIN ratlnk_grpmodlang AS gml ON gml.grpmod_id=m.grpmod_id AND gml.lang_id=l.lang_id
      INNER JOIN ratlnk_modgrp AS mg ON mg.mod_id=m.mod_id
      INNER JOIN ratlnk_grppers AS gp ON gp.grp_id=mg.grp_id AND gp.pers_id='.$userid.'
      INNER JOIN ratlnk_modlang AS ml ON ml.mod_id=m.mod_id AND ml.lang_id=l.lang_id
    ORDER BY gml.grl_nom, ml.mol_texte');
  if($req->next_record())
    {
    $count = 1;
    $groupe = $req->f('grl_nom');
    $bloc = '';
    do
      {
      if($req->f('grl_nom')!=$groupe || ($bloc!='' && $req->stat==false))
        {
        $tpl->assign('NOM_GROUPE', $groupe);
        $tpl->assign('IDLISTE', ''.$count);
        $tpl->assign('GROUPE', '<option value="'.$selected.'"></option>'.$bloc);
        $tpl->parse('BARRE.GRP');
        $groupe = $req->f('grl_nom');
        $count++;
        $bloc = '';
        }
      if($req->stat)
        {
        $state = $req->f('mod_ident')==$selected ? ' selected' : '';
        $bloc .= '<option value="'.$req->f('mod_ident').'"'.$state.'>'.$req->f('mol_texte').'</option>';
        }
      }
    while($req->next_record() || $bloc!='');
    }
  else trigger_error("admin menu vide, aucun module autorise<user>$userid</user><lang>$langid</lang>", E_USER_WARNING);
  }

/**************************************************************************************
  si ya une tentative de login en cours
**************************************************************************************/
if(isset($HTTP_POST_VARS['login']))
  {
  $id_personne = Personne_login($HTTP_POST_VARS['login'], $HTTP_POST_VARS['password']);
  if($id_personne!=0)
    {
    $Session['id_personne'] = $id_personne;
		$Session['login'] = $HTTP_POST_VARS['login'];
    $Session['id_langue'] = $HTTP_POST_VARS['langue'];
		AddLog("<action>entre</action><pers>".TxtXml($HTTP_POST_VARS['login'])."</pers><lang>".TxtXml($HTTP_POST_VARS['langue'])."</lang>", "login_ok.log");
    }
  else 
		{
		$message = MSG_UNKNOWNUSER;
		AddLog("<bad>".TxtXml($HTTP_POST_VARS['login'])."</bad><lang>".TxtXml($HTTP_POST_VARS['langue'])."</lang><pwd>".TxtXml($HTTP_POST_VARS['password'])."</pwd>", "login_err.log");
		}
  }

/**************************************************************************************
  si la personne est deja identifie et sa session encore valide (vrification par la lib gsessions)
**************************************************************************************/
if(isset($Session['id_personne']))
  {
	//dconnexion
	if(isset($HTTP_GET_VARS['cmd_logout'])) 
		{
		echo "au revoir<br>";
		gsession_die();
		die();
		}
	
  //valeurs par dfaut et rcupration des infos
  if(!isset($Session['site'])) $Session['site'] = Site_premier($Session['id_personne']);
  GetParam('newsite', $site, $Session['site']);
	//nettoyage de la session lors du changement de site
	if($site!=$Session['site']) 
		{
		$module = 'accueiladmin';
		$reset_site = 1;
		}
		
  if(!isset($Session['module'])) $Session['module'] = 'accueiladmin';
  GetParam('newmodule', $module, $Session['module']);
  if(!isset($Session['mode'])) $Session['mode'] = 'principal';

  //inclusion des parametres du site
  define('CHEMIN_SITE', CHEMIN_SITES.Site_nom($Session['site']).'/');
  include CHEMIN_SITE.'site.php';

  //gnration du haut de page
  $tpl = ModeleAdmin('admin.html');
  $tpl->assign('SID', $GS);
  $tpl->assign('HIDDEN', $HGS);
  $tpl->assign('MODULE', Module_Nom($module, $LangueEdition));
  $tpl->assign('TXT_SITE', MSG_SITE);
  $tpl->assign('LSTSITES', LstSitesUser($Session['id_personne'], $site));
  $tpl->assign('TXT_LANGUE', MSG_LANGUE);
  $tpl->assign('LISTELANGUES', ComboLangues($LangueEdition));
  AdminMenu($Session['id_personne'], $Session['langue_interface'], $module, $tpl);
  $tpl->assign('VERSION', VERSION);
  $tpl->assign('SITE', Site_Nom($site));
  $tpl->assign('PERSONNE', Personne_Nom($Session['id_personne']));
  $tpl->parse('BARRE');
  $tpl->out('BARRE');

/****************************************************************************************************
* appel de l'action du module en cours
****************************************************************************************************/
  $datamodule = array();
  if(isset($Session['module'])) if(isset($Session['datamodule_'.$Session['module']]))
    $datamodule = $Session['datamodule_'.$Session['module']];

  //debug
  if(defined('DEBUGMODE'))
    {
    echo '<table border="0" bgcolor="#CC9900"><tr><td>';
    echo "<b>POST</b> "; print_r($HTTP_POST_VARS); echo "<br><b>GET</b> "; print_r($HTTP_GET_VARS); echo "<br>";
    echo "<b>datamodule</b> "; print_r($datamodule); echo "<br><b>session</b> "; print_r($Session); echo "<br>";
    }

  FonctionModule($Session['module'], 'definitions', 1);
  if(defined('DEBUGMODE')) echo "act-debut ".$Session['module']."  (mode ".$Session['mode'].") // ";
  FonctionModule($Session['module'], $Session['mode'].'-act');
  if(defined('DEBUGMODE')) echo "act-fin<br>";

/****************************************************************************************************
* chargement des infos en session
****************************************************************************************************/
  $mode = $Session['mode'];
  if($site!=$Session['site']) $mode = 'principal';
  if($module!=$Session['module'])
    {
    $mode = 'principal';
    if(isset($Session['datamodule_'.$module])) $datamodule = $Session['datamodule_'.$module];
    else $datamodule = array();
    $appel_definitions = 1;
    }
  $Session['site'] = $site;
  $Session['module'] = $module;
  $Session['mode'] = $mode;
	if(isset($reset_site)) //suppression de la session sur changement de site
		{
		reset($Session);
		while(list($id,)=each($Session))
			if(substr($id, 0, strlen('datamodule_'))=='datamodule_') unset($Session[$id]);
		}
		
/****************************************************************************************************
* appel de l'affichage du module en cours
****************************************************************************************************/
  $Session['langue_edition'] = $LangueEdition;

  if(isset($appel_definitions)) FonctionModule($Session['module'], 'definitions', 1);
  if(defined('DEBUGMODE')) echo "aff-debut ".$Session['module']."  (mode ".$Session['mode'].") // ";
  FonctionModule($Session['module'], $Session['mode'].'-aff');
  if(defined('DEBUGMODE')) echo "aff-fin<br>";

  $tpl->assign('CODEMODULE', $module_ecran);

/****************************************************************************************************
* reste de l'affichage
****************************************************************************************************/

  //affichage des messages
  if(isset($admmessages))
    {
    for($ct=0, $max=count($admmessages); $ct<$max; $ct++)
      {
      $tpl->assign('MESSAGE', $admmessages[$ct]);
      $tpl->parse('RESTE.MESSAGES.MESSAGE');
      }
    $tpl->assign('MSG_MESSAGESAPPLICATION', MSG_MESSAGESAPPLICATION);
    $tpl->parse('RESTE.MESSAGES');
    }

  if(defined('DEBUGMODE')) echo '</td></tr></table>';

  $tpl->parse('RESTE');
  $tpl->out('RESTE');

  //on sauve le datamodule
  if(isset($Session['module']))
  if(!empty($datamodule)) $Session['datamodule_'.$Session['module']] = $datamodule;
  else $Session['datamodule_'.$Session['module']] = array();

  if(defined('DEBUGMODE'))
    {
    echo '<table border="0" bgcolor="#CC9900"><tr><td>';
    echo "<b>datamodule</b> "; print_r($datamodule); echo "<br>";
    echo "<b>session</b> "; print_r($Session); echo "<br>";
    echo '</td></tr></table>';
    }

  }

/**************************************************************************************
  sinon on demande l'identification
**************************************************************************************/
else
  {
  $tpl = ModeleAdmin('identification.html');
  if(isset($message))
    {
    $tpl->assign('MESSAGE', $message);
    $tpl->parse('MAIN.MESSAGE');
    }
  $tpl->assign('IDENTIFIANT', MSG_IDENTIFIANT);
  $tpl->assign('MOTDEPASSE', MSG_MOTDEPASSE);
  $tpl->assign('VALIDER', MSG_VALIDER);
  $tpl->assign('HIDDEN', $HGS.'<input type="hidden" name="langue" value="'.$Session['langue_interface'].'">');
  $langues_liste = explode(',', RATLANGUES_LISTE);
  while(list(,$l)=each($langues_liste))
    {
    $tpl->assign('LANGUE', $LANGUES[$l]);
    $tpl->assign('URL', '?langint='.$l);
    $tpl->parse('MAIN.LANGUE');
    }

  $tpl->parse('MAIN');
  $tpl->out('MAIN');
  }

echo "<table bgcolor='#CCCCCC'><tr><td>Temps d'excution : ",getmicrotime() - $time, " secondes</td></tr></table>";
?>
