<?php
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = classe mre matrisant l'accs  un enregistrement (lecture/insertion/sauvegarde)
* *************************************************************************************
* Creation mars 2002
* valid
**************************************************************************************/

define('typeChaine', 'chaine');
define('typeEntier', 'entier');
define('typeDate', 'date');

class CDBClasse
  {
  var $nom;
  var $champs;

  function CDBClasse($nom)
    //init
    {
    $this->nom = $nom;
    $this->champs = array();
    }

  function Ecrire($champ, $valeur)
    //change la valeur d'un champ
    {
    $id = $this->Chercher($champ);
    if($id!=-1)
      {
      $this->champs[$id]['valeur'] = $valeur;
      $this->champs[$id]['change'] = true;
      }
    else trigger_error("champ $champ non trouve dans CDBClasse(".TxtXml($this->nom).")", E_USER_WARNING);
    }

  function Lire($champ)
    //lit la valeur d'un champ
    {
    $id = $this->Chercher($champ);
    if($id==-1) trigger_error("champ $champ non trouve dans CDBClasse(".TxtXml($this->nom).")", E_USER_WARNING);
    elseif(isset($this->champs[$id]['valeur'])) return $this->champs[$id]['valeur'];
    elseif(isset($this->champs[$id]['defaut'])) return $this->champs[$id]['defaut'];
    else trigger_error("champ $champ sans valeur ni valeur par dfaut dans CDBClasse(".TxtXml($this->nom).")", E_USER_WARNING);
    }

  function SqlInsert($table)
    //calcule le sql d'insertion des valeurs
    {
    $champs = '';
    $valeurs = '';
    $ct = 0;
    $max = count($this->champs);
    while($ct<$max)
      {
      $v = $this->champs[$ct];
      if($v['table']==$table)
        {
        if(isset($v['valeur'])) $val = $v['valeur'];
        elseif(isset($v['defaut'])) $val = $v['defaut'];
        else { $ct++; continue; }
        if($v['type']==typeChaine) $val = '"'.TxtSql($val).'"';
        elseif($v['type']==typeDate) $val = '"'.date_p2m($val).'"';
        $valeurs .= $val.',';
        $champs .= $v['nom'].',';
        }
      $ct++;
      }

    if($champs!='' && $valeurs!='') return 'INSERT INTO '.$table.'('.substr($champs, 0, strlen($champs)-1).
      ') VALUES('.substr($valeurs, 0, strlen($valeurs)-1).')';
    else return '';
    }

  function SqlUpdate($table, $where)
    //calcule le sql de mise  jour des valeurs
    {
    $champs = '';
    $ct = 0;
    $max = count($this->champs);
    while($ct<$max)
      {
      $v = $this->champs[$ct];
      if($v['table']==$table && isset($v['change']))
        {
        if($v['type']==typeChaine) $val = '"'.TxtSql($v['valeur']).'"';
        elseif($v['type']==typeDate) $val = '"'.date_p2m($v['valeur']).'"';
        else $val = $v['valeur'];
        $champs .= $v['nom'].'='.$val.',';
        }
      $ct++;
      }

    if($champs!='') return 'UPDATE '.$table.' SET '.substr($champs, 0, strlen($champs)-1).' '.$where;
    else return '';
    }

  function SqlSelect($table, $where)
    //calcule le sql de rcupration des valeurs
    {
    $champs = '';
    $ct = 0;
    $max = count($this->champs);
    while($ct<$max)
      {
      $v = $this->champs[$ct];
      if($v['table']==$table) $champs .= $v['nom'].',';
      $ct++;
      }

    return 'SELECT '.substr($champs, 0, strlen($champs)-1).' FROM '.$table.' '.$where;
    }

  function ChargerDB($table, $where)
    //charge les valeurs des champs  partir de la base de donnes
    {
    $req = NewQuery($this->SqlSelect($table, $where));
    if($req->num_rows()!=1) return -1;
    else
      {
      $req->next_record();
      reset($this->champs);
      while(list($key, $val)=each($this->champs)) if($val['table']==$table)
        $this->champs[$key]['valeur'] = $req->f($val['nom']);
      }
    }

  function Chercher($champ)
    //cherche un champ
    {
    $ct = 0;
    $max = count($this->champs);
    while($ct<$max && $this->champs[$ct]['nom']!=$champ) $ct++;
    if($ct>=count($this->champs)) return -1; else return $ct;
    }

  function Acces($champ, $valeur="")
    //accs  un champ en lecture ou ecriture
    {
    if($valeur!='') $this->Ecrire($champ, $valeur);
    else return $this->Lire($champ);
    return '';
    }

  function Afficher()
    //affiche la liste des champs
    {
    $ct = 0;
    $max = count($this->champs);
    while($ct<$max)
      {
      print_r($this->champs[$ct]);
      echo "<br>";
      $ct++;
      }
    }
  }

?>