
<?
/**************************************************************************************
  PRESENTATION version 0.9
  Gsessions est un manager de session pour php 3 et 4, qui passe l'IDSESSION par GET
  ou POST, sans cookies. Il est bas sur le code de Kyle Cordes, KCSM 0.1 
	(kyle@kylecordes.com http://www.kylecordes.com)

  Cdric Girard
**************************************************************************************/

/**************************************************************************************
  HISTORIQUE
  26/10/2001
     - tablissement d'une dure de vie pour les sessions, suppression du fichier
     - fonction de suppression des sessions abandonnes
     - utilisation de constantes  la place de variables
     - fonction de fin de session volontaire
  02/04/2001
    - debut de la reprise du code
    - passage du sessionid en get ou post
    - suppression de la fonction start
**************************************************************************************/

/*************************************************************************************
  FONCTIONS
*************************************************************************************/
if(defined('LIB_GSESSIONS_PHP')) return '';
define('LIB_GSESSIONS_PHP', 1);

global $GS, $HGS, $SessionID, $Session, $datamodule, $HTTP_GET_VARS, $HTTP_POST_VARS;

function gsessions_end()
  //fin de la page, appele automatiquement
  {
  global $SessionID, $Session;
	
  if(isset($Session))
    {
    $filename = CHEMIN_SESSIONS.$SessionID;
    $fd = fopen($filename, "w");
    if(!$fd) trigger_error("Erreur dans l'ouverture du fichier de session", E_USER_WARNING);

    $Session['session_time_used'] = time();
    $contents = serialize($Session);
    fwrite($fd, $contents);
    fclose($fd);
    }
	gsessions_clean();
  }

function gsessions_show()
  //affichage pour test
  {
  global $Session;

  if(is_array($Session))
    {
    reset($Session);
    echo "<br>Session<br>";
    while (list($key, $val)=each($Session))
      echo '$Session["'.$key.'"]="'.$val.'"<br>';
    echo "<br>";
    }
  else echo "Pas de session dfinie<br>";
  }

function gsessions_clean()
  //nettoyage des anciennes sessions
  {
	global $Session; 
	
  $dir=dir(CHEMIN_SESSIONS);
  while($fichier = $dir->read()) if(substr($fichier, 0, 3)==IDFICHIER)
    {
    $fd = fopen(CHEMIN_SESSIONS.$fichier, "r-");
    $contents = fread($fd, filesize(CHEMIN_SESSIONS.$fichier));
    fclose($fd);
    $Session = unserialize($contents);

    if(time()-$Session['session_time_used']>SESSIONLIFE) gsession_destroy($fichier, $Session);
    }
  }
	
function gsession_die()
  //fin de la session actuelle
  {
  global $SessionID, $Session;

  if(file_exists(CHEMIN_SESSIONS.$SessionID)) gsession_destroy($SessionID, $Session);
	unset($Session);
  unset($SessionID);
  }
	
function gsession_destroy($SessionID, $Session)
	{
	AddLog('<action>sortie</action><pers>'.TxtXml($Session['login']).'</pers>'
		.'<debut>'.TxtXml(date('d/M/Y H:i:s', $Session['session_time_begin'])).'</debut>'
		.'<fin>'.TxtXml(date('d/M/Y H:i:s', $Session['session_time_used'])).'</fin>'
		, 'login_ok.log');
	unlink(CHEMIN_SESSIONS.$SessionID);
	}

/*************************************************************************************
  INITIALISATION DE LA SESSION
*************************************************************************************/
register_shutdown_function("gsessions_end");
//pas besoin d'appeler un script  la fin des pages

if(isset($HTTP_GET_VARS['SessionID'])) $SessionID = $HTTP_GET_VARS['SessionID'];
elseif(isset($HTTP_POST_VARS['SessionID'])) $SessionID = $HTTP_POST_VARS['SessionID'];

if(@$SessionID)
  {  //recupre la session existante
  $filename = CHEMIN_SESSIONS.$SessionID;
  if(file_exists($filename))
    {
    $fd = fopen($filename, "r-");
    if(! $fd)
      {
			trigger_error("Erreur dans l'ouverture du fichier de session", E_USER_WARNING);
      $Session = array();
      }
    $contents = fread( $fd, filesize( $filename ) );
    fclose($fd);
    $Session = unserialize($contents);

    if(time()-$Session['session_time_used']>SESSIONLIFE)
      {
        //expiration de la session, on en commence une autre
        unlink($filename);
        $SessionID = IDFICHIER.md5(uniqid(""));
        $Session = array();
				$Session['session_time_begin'] = time();
      }
    }
  }
else //il n'y en a plus, on en commence une autre
  {
  $SessionID = IDFICHIER.md5(uniqid(""));
  $Session = array();
	$Session['session_time_begin'] = time();  
	}

$GS='SessionID='.$SessionID.'&foo='.uniqid('');
$HGS='<input type="hidden" name="SessionID" value="'.$SessionID.'">';
?>